<?php
/*
Plugin Name: Ajax in the WordPress Admin Demo
Plugin URI: http://suoling.net/
Description: This is a simple ajax example based on Pippin Williamson's demo to show how to use ajax in the wordpress admin.
Version: 1.0
Author: suifengtec,Pippin Williamson
Author URI: http://suoling.net/
Contributors: suifengtec,mordauk
*/

/*
	Notice:简单的注释就不用中文了.
*/

/*Exit if accessed directly:安全第一,如果是直接载入,就退出.*/
defined( 'ABSPATH' )  or exit;

/*Define a(some) Constant(s)*/
defined('AAD_PLUGIN_URL') or define('AAD_PLUGIN_URL', plugin_dir_url( __FILE__ ));

/*
	I18n
*/
function aad_load_textdomain() {

	$aad_lang_dir = dirname( plugin_basename( __FILE__ ) ) . '/lang/';
	load_plugin_textdomain( 'aad', false, $aad_lang_dir );

}
add_action( 'init', 'aad_load_textdomain' );

function aad_admin_page() {
	/*添加菜单，并指定一个全局Hook给它*/
	global $aad_settings;
	/*
		Add sub menu page to the Settings menu:这个API将会把你想添加的菜单添加到setting(设置)菜单下;
		add_options_page( $page_title, $menu_title, $capability, $menu_slug, $function);
		我们要将自己的菜单添加为顶级菜单，所以，不用这个了。
	*/
	//$aad_settings = add_options_page(__('Admin Ajax Demo', 'aad'), __('Admin Ajax', 'aad'), 'manage_options', 'admin-ajax-demo', 'aad_render_admin');


	/*
		add_menu_page( $page_title, $menu_title, $capability, $menu_slug, $function, $icon_url, $position );
		$position可选：
			 2 Dashboard=替代原有的仪表盘(首页),不合适;
			 4 Separator=仪表盘(首页)和文章之间分割线的位置;
			 5 Posts=仪表盘(首页)和文章之间正常的位置,这时候它和仪表盘(首页)的分割线还在
			 10 Media=替代原有的多媒体的位置;
			 15 Links=在新版本的Wordpress中,Link功能默认是隐藏的，也就是默认的，你是看不到这个菜单项的，所以这个位置也是可以的;
			 20 Pages=替代菜单项“页面”,不合适;
			 25 Comments=替代菜单项“评论”,不合适;
			 59 Separator=替代评论和外观之间分割线的位置,可以;
			 60 Appearance=替代菜单项“外观”,不合适;
			 65 Plugins=替代菜单项“插件”,不合适;
			 70 Users=替代菜单项“用户”,不合适;
			 75 Tools=替代菜单项“工具”,不合适;
			 80 Settings=替代菜单项“设置”,不合适;
			 99 Separator=替代WP后台菜单最下侧的分割线的位置,合适;
			 可以更大吗？可以。

	*/
	 /*
		使用自制的icon作为菜单项的标志
	 */
	//$aad_settings = add_menu_page(__('Admin Ajax Demo', 'aad'), __('Admin Ajax', 'aad'), 'manage_options', 'admin-ajax-demo','aad_render_admin', AAD_PLUGIN_URL. 'img/ajax.png', 99);
	/*
		准备使用wordpress自带的dashicon作为菜单项的标志,所以把$icon_url的值置为false
	*/
	$aad_settings = add_menu_page(__('Admin Ajax Demo', 'aad'), __('Admin Ajax', 'aad'), 'manage_options', 'admin-ajax-demo','aad_render_admin',false, 99);


}
add_action('admin_menu', 'aad_admin_page');

function aad_style(){

	/*
		css内容较少的情况下,使用admin_head这个hook直接输出比较合适;如果css内容较多,使用自制的icon作为菜单项的标志用admin_enqueue_scripts这个Hook载入css文件比较合适.
	*/


	/*
		限制菜单项前面的icon的尺寸
	*/
	//$output='<style>#toplevel_page_admin-ajax-demo .wp-menu-image img{width:20px;height:20px;}</style>';

	/*
		使用Wordpress自带的图标字体dashicons;
		更多详情:http://suoling.net/wordpress-dashicons/
	*/
	$output='<style>#adminmenu #toplevel_page_admin-ajax-demo .wp-menu-image:before {content: "\f321";}</style>';

echo $output;
}

add_action('admin_head','aad_style');

/*
开始处理页面输出
*/
function aad_render_admin() {
	?>
	<div class="wrap">
		<h2><?php _e('Admin Ajax Demo', 'aad'); ?></h2>
		<!-- 一个很简单的示例表单 -->
		<form id="aad-form" action="" method="POST">
			<div>
				<input type="submit" name="aad-submit" id="aad_submit" class="button-primary" value="<?php _e('Get Results', 'aad'); ?>"/>
				<img src="<?php echo admin_url('/images/wpspin_light.gif'); ?>" class="waiting" id="aad_loading" style="display:none;"/>
			</div>
		</form>
		<!-- 用于显示结果的自定义节点 -->
		<div id="aad_results"></div>
	</div>
	<?php
}

function aad_load_scripts($hook) {
	global $aad_settings;
	/*用上了前面定义的全局菜单Hook,如果不是这个,就返回*/
	if( $hook != $aad_settings )
		return;
	/*载入ajax的js文件,也可以载入其他的javascript和/或css等*/
	wp_enqueue_script('aad-ajax', AAD_PLUGIN_URL . 'js/aad-ajax.js', array('jquery'));
	/*
		创建验证nonce
		它会输出类似于：
		<![CDATA[
		var aad_vars = {"aad_nonce":"5c18514d34"};
		]]>
		之类的被注释掉的js到HTML。
	*/
	wp_localize_script('aad-ajax', 'aad_vars', array(
			'aad_nonce' => wp_create_nonce('aad-nonce')
		)
	);

}
add_action('admin_enqueue_scripts', 'aad_load_scripts');

function aad_process_ajax() {

	/*用nonce进行权限验证，以保证安全*/
	if( !isset( $_POST['aad_nonce'] ) || !wp_verify_nonce($_POST['aad_nonce'], 'aad-nonce') )
		die('Permissions check failed');

	/*
		Output something via ajax!
	*/
	$posts = get_posts(array('post_type' => 'post', 'posts_per_page' => 5));
	if( $posts ) :
		echo '<ul>';
			foreach($posts as $post) {
				echo '<li>' . get_the_title($post->ID) . ' - <a href="' . get_permalink($post->ID) . '">' . __('View post', 'aad') . '</a></li>';
			}
		echo '</ul>';
	else :
		echo '<p>' . __('No results found', 'aad') . '</p>';
	endif;

	die();
}
add_action('wp_ajax_aad_get_results', 'aad_process_ajax');
/////////////////////////////////////////Yeah!All done!